<template>
    <div :class="$style.chart">
        <div class="text1" :class="$style.title">{{ title }}</div>
        <Line :data="chartData" :options="chartOptionsObj"> </Line>
    </div>
</template>

<script>
import { Chart as ChartJS, CategoryScale, LinearScale, PointElement, LineElement, Title, Tooltip } from 'chart.js'
import { Line } from 'vue-chartjs'
import { formatBigNumbers } from '@/utils/utils'
// eslint-disable-next-line
// import * as chartConfig from './chartConfig.js'

ChartJS.register(CategoryScale, LinearScale, PointElement, LineElement, Title, Tooltip)

export default {
    name: 'ChartComponent',
    components: {
        Line,
    },

    props: {
        title: {
            type: String,
            default: '',
        },
        chartData: {
            type: Object,
            default: () => ({}),
        },
        chartOptions: {
            type: Object,
            default: () => ({}),
        },
        labelOptions: {
            type: Object,
            default: () => ({}),
        },
    },

    data() {
        return {
            defaultChartOptions: {
                interaction: {
                    intersect: false,
                },
                // responsive: true,
                maintainAspectRatio: false,
                scales: {
                    y: {
                        ticks: {
                            color: '#b6baca',
                        },
                        grid: {
                            drawTicks: false,
                        },
                        // border: {
                        //     dash: [5, 10],
                        // },
                    },
                    x: {
                        ticks: {
                            color: '#b6baca',
                        },
                        grid: {
                            display: false,
                        },
                        border: {
                            display: false,
                        },
                    },
                },
            },
        }
    },

    computed: {
        chartOptionsObj() {
            return {
                ...this.chartOptions,
                interaction: {
                    intersect: false,
                },
                // responsive: true,
                maintainAspectRatio: false,
                scales: {
                    y: {
                        ticks: {
                            color: '#b6baca',
                        },
                        grid: {
                            drawTicks: false,
                        },
                        // border: {
                        //     dash: [5, 10],
                        // },
                    },
                    x: {
                        ticks: {
                            color: '#b6baca',
                        },
                        grid: {
                            display: false,
                        },
                        border: {
                            display: false,
                        },
                    },
                },
                //-----------------------
                plugins: {
                    tooltip: {
                        callbacks: {
                            label: function (context) {
                                let label = `${formatBigNumbers(context.parsed.y)} Impressions`
                                return label
                            },
                            labelColor: function () {
                                return {
                                    border: 'none',
                                    backgroundColor: 'rgb(255, 255, 255)',
                                    boxShadow: '0px 32px 0px 0px #f8f7fb',
                                    borderRadius: 12,
                                    color: '#1c1726',
                                }
                            },
                            beforeLabel: () => ' ',
                            beforeTitle: () => ' ',
                            // usePointStyle: true,
                            // // labelTextColor: function () {
                            // //     return '#1c1726'
                            // // },
                            // labelPointStyle: function () {
                            //     return {
                            //         // usePointStyle: false,
                            //         pointStyle: 'triangle',
                            //         rotation: 0,
                            //     }
                            // },
                            ...this.labelOptions,
                        },
                    },
                },
            }
        },
    },
}
</script>

<style module>
.chart {
    height: 250px;
}
.title {
    margin-bottom: 16px;
    font-size: 16px;
    font-weight: 700;
    line-height: 20px;
}
</style>
